ProjOpenCoastS/urls.py
from django.conf.urls import url, include
from django.contrib import admin


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^auth/', include('django_auth_oidc.urls')),
    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r'^', include('front.urls')),
    url(r'^wizard/', include('wizard.urls')),
    url(r'^viewer/', include('viewer.urls')),

    url(r'^raster/', include('raster.urls')),
    url(r'^satellite/', include('satellite.urls')),
]

handler400 = 'front.views.handler400'
handler403 = 'front.views.handler403'
handler404 = 'front.views.handler404'
handler500 = 'front.views.handler500'

front/urls.py
from django.conf.urls import url
from .views import *
from django.views.generic import TemplateView

# TODO: when there is more than one app: point to views inside 'front' redirecting to the app selected by the user
from wizard.views import deployments, new_deploy, view_deploy, open_deploy, clone_deploy, deactivate_deploy, \
    reactivate_deploy, delete_deploy, extend_deploy, view_extend_deploys, get_file, get_definition, print_deploy, \
    get_deploys, get_boundaries


urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^home/$', home, name='home'),
    url(r'^login/$', Login.as_view(), name='login'),
    url(r'^logout/$', logout_user, name='logout'),
    url(r'^register/$', register, name='register'),
    url(r'^register/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', register_confirm, name='register_confirm'),
    url(r'^profile/$', profile, name='profile'),
    url(r'^disclaimer/$', disclaimer, name='disclaimer'),

    url(r'^ratings/$', rate_service, name='rate_service'),

    url(r'^password/change/$', password_change, name='password_change'),
    url(r'^password/recover/$', password_recover, name='password_recover'),
    url(r'^password/recover/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', password_recover_confirm, name='password_recover_confirm'),

    url(r'^userprofile/activate/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', userprofile_activate, name='userprofile_activate'),
    url(r'^activate_user/(?P<username>[\w.%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4})/$', activate_user, name='activate_user'),

    url(r'^login_egi/$', login_egi, name='login_egi'),
    url(r'^login_egi/complete/$', login_egi_complete, name='login_egi_complete'),
    url(r'^logout_egi/$', logout_egi, name='logout_egi'),

    url(r'^deployments/$', deployments, name='deployments'),
    url(r'^deployments/new/$', new_deploy, name='new_deploy'),
    url(r'^deployments/view/(?P<deploy_id>[0-9]+)/$', view_deploy, name='view_deploy'),
    url(r'^deployments/open/(?P<deploy_id>[0-9]+)/$', open_deploy, name='open_deploy'),
    url(r'^deployments/clone/(?P<deploy_id>[0-9]+)/$', clone_deploy, name='clone_deploy'),
    url(r'^deployments/deactivate/(?P<deploy_id>[0-9]+)/$', deactivate_deploy, name='deactivate_deploy'),
    url(r'^deployments/reactivate/(?P<deploy_id>[0-9]+)/$', reactivate_deploy, name='reactivate_deploy'),
    url(r'^deployments/delete/(?P<deploy_id>[0-9]+)/$', delete_deploy, name='delete_deploy'),
    url(r'^deployments/extend/$', extend_deploy, name='extend_deploy'),
    url(r'^deployments/view_extends/$', view_extend_deploys, name='view_extend_deploys'),
    url(r'^deployments/get_deploys/$', get_deploys, name='get_deploys'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/$', get_definition, name='get_definition'),
    url(r'^deployments/get_definition/(?P<name>[[\w\-]+)/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)$', get_definition, name='get_definition'),

    url(r'^deployments/file/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)/(?P<name>[[\w\-]+)/(?P<format>[[\w\-]+)/$', get_file, name='get_file'),
    url(r'^deployments/print/(?P<deploy_id>[0-9]+)/$', print_deploy, name='print_deploy'),
    url(r'^print/$', TemplateView.as_view(template_name="front/modal/printdeploy.html"), name='print'),

    url(r'^deployments/get_boundaries/(?P<deploy_id>[0-9]+)/$', get_boundaries, name='get_boundaries'),

    url(r'^download_file/(?P<file_cat>[[\w\-]+)/(?P<file_id>[0-9]+)/$', download_file, name='download_file'),

    url(r'^run_stats/monthly_time/(?P<year>\d{4})/(?P<month>\d{2})$', monthly_run_time),
]

front/views.py
# -*- coding: utf-8 -*-
import requests

from django.shortcuts import render, redirect, HttpResponseRedirect, HttpResponse
from django.utils.html import escape
from django.utils.translation import ugettext_lazy as _

from django.utils.http import urlsafe_base64_encode, urlsafe_base64_decode
from django.utils.encoding import force_bytes
from django.urls import reverse
from django.contrib.auth.hashers import make_password
from django.contrib.auth.tokens import default_token_generator

from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.decorators import login_required
from django.views.generic import View
from django.contrib.auth.forms import AdminPasswordChangeForm, PasswordChangeForm
from django.contrib.auth import update_session_auth_hash

from django.http import JsonResponse

from .utils import *
from .forms import *
from .models import UserProfile, UserProfileRating, SessionFile
from datamodel.models import DeploymentFile

app_name = 'front'


# View for Errors
def handler400(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Pedido inválido.')})
    response.status_code = 400
    return response


def handler403(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Permissões insuficientes.')})
    response.status_code = 403
    return response


def handler404(request, exception, template_name="front/error.html"):
    response = render(request, 'front/error.html', {'error': _('Página não encontrada.')})
    response.status_code = 404
    return response


def handler500(request):
    response = render(request, 'front/error.html', {'error': _('Erro de servidor.')})
    response.status_code = 500
    return response


# View for index
def home(request):
    return render(request, 'front/home.html', {'user': request.user, 'default_email': settings.DEFAULT_FROM_EMAIL})


# Class for login
class Login(View):
    form_class = AuthenticationForm
    template_name = 'front/login.html'

    def get(self, request):
        if request.user.is_authenticated:
            # If first session ever open in step1
            if not request.user.profile.read_disclaimer:
                return redirect('/wizard/step1')
            else:
                # If neither open deployments management page
                return redirect('/deployments')
        else:
            form = self.form_class(None)
            return render(request, self.template_name, {'form': form})

    def post(self, request):
        username = escape(request.POST['username'])
        password = escape(request.POST['password'])

        user = authenticate(username=username, password=password)
        if user is not None:
            if user.is_active:
                login(request, user)

                if 'next' in request.GET:
                    gonext = request.GET['next']
                    return HttpResponseRedirect(gonext)
                else:
                    # If first session ever open in step1
                    if not request.user.profile.read_disclaimer:
                        return redirect('/wizard/step1')
                    else:
                        # If neither open deployments management page
                        return redirect('/deployments')

            else:
                response = _('A sua conta encontra-se desativada!')
                return render(request, self.template_name, {'response': response})
        else:
            response = _('Entrada em sessão inválida!')
            return render(request, self.template_name, {'response': response})


# View for register
def register(request):
    response = None

    if request.method == 'POST':
        user_form = RegistrationForm(request.POST)
        profile_form = ProfileForm(request.POST)

        if user_form.is_valid() and profile_form.is_valid():
            # Save new User -> username = email
            new_user = user_form.save(commit=False)
            new_user.email = new_user.username
            new_user.save()

            if new_user:
                # Save profile info to new User
                new_profile = profile_form.save(commit=False)
                new_profile.user = new_user
                new_profile.save()
                profile_form.save_m2m()

                # Send email notifying user's register
                token = default_token_generator.make_token(new_user)
                uidb64 = urlsafe_base64_encode(force_bytes(new_user.pk))
                confirmation_link = request.build_absolute_uri(reverse('front:register_confirm', kwargs={'uidb64': uidb64, 'token': token}))

                notify_registration(new_user, new_profile, confirmation_link)

                response = _('Por favor verifique a sua conta de email (incluindo SPAM). Receberá um email para confirmar o seu registo. '
                             'Assim que o seu registo for confirmado e validado com sucesso receberá um email da ativação da conta.')

                profile_form = None
                user_form = None
            else:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        if request.user.is_authenticated:
            return redirect('/home', {'user': request.user})
        else:
            user_form = RegistrationForm(None)
            profile_form = ProfileForm(None)

    return render(request, 'front/register.html', {'profile_form': profile_form, 'user_form': user_form, 'response': response})


# View for user register confirmation
def register_confirm(request, uidb64, token):
    try:
        # User confirming registration via OPENCoastS - if valid send notification to LNEC
        new_user = User.objects.get(pk=urlsafe_base64_decode(uidb64))
        token_valid = default_token_generator.check_token(new_user, token)

        if token_valid:
            # Already active? no need for confirmation, go to login
            if new_user.is_active:
                return redirect('/login')
            else:
                new_profile = UserProfile.objects.get(user=new_user)

                if new_profile.confirm_registration:
                    response = _('Ocorreu um erro! Este URL não é válido ou já expirou.')
                else:
                    # Mark registration confirmation in DB
                    new_profile.confirm_registration = True
                    new_profile.save()
                    response = _('Registo confirmado! Assim que o seu registo for validado com sucesso receberá um email da ativação da conta.')

                    # Send user activation link to DEFAULT_FROM_EMAIL
                    activation_link = request.build_absolute_uri(reverse('front:userprofile_activate', kwargs={'uidb64': uidb64, 'token': token}))
                    notify_confirm_registration(new_user, new_profile, activation_link)
        else:
            response = _('Ocorreu um erro! Este URL não é válido ou já expirou.')

    except Exception:
        logger.exception('Error on register confirm')
        response = _('Ocorreu um erro! Por favor tente mais tarde.')

    return render(request, 'front/register.html', {'response': response})


# View for Profile
@login_required(login_url='/login/')
def profile(request):
    response = None

    if request.method == 'POST':
        user_form = UserForm(request.POST, instance=request.user)
        profile_form = FullProfileForm(request.POST, instance=request.user.profile)
        if user_form.is_valid() and profile_form.is_valid():
            try:
                user_form.save()
                profile_form.save()
                response = _('O seu perfil foi atualizado com sucesso!')
            except:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
        else:
            response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        if not request.user.is_authenticated:
            return redirect('/home', {'user': request.user})
        else:
            user_form = UserForm(instance=request.user)
            profile_form = FullProfileForm(instance=request.user.profile)

    # Distinguish between normal users from EGI users (these cannot change passwords)
    disable_password = False
    if request.user.password == '***':
        disable_password = True

    return render(request, 'front/profile.html', {'user_form': user_form, 'profile_form': profile_form, 'response': response, 'disable_password': disable_password})


# View for Password update
@login_required(login_url='/login/')
def password_change(request):
    response = None

    if request.user.has_usable_password():
        pwd_form = PasswordChangeForm
    else:
        pwd_form = AdminPasswordChangeForm

    if request.method == 'POST':
        form = pwd_form(request.user, request.POST)
        if form.is_valid():
            try:
                form.save()
                update_session_auth_hash(request, form.user)
                response = _('A sua palavra-passe foi alterada com sucesso!')
            except:
                response = _('Ocorreu um erro! Por favor tente mais tarde.')
        else:
            response = _('Ocorreu um erro! Por favor tente mais tarde.')
    else:
        form = pwd_form(request.user)

    return render(request, 'front/password.html', {'pwd_form': form, 'response': response})


# View for Password recover - open reset pwd form
def password_recover_confirm(request, uidb64, token):
    token_valid = False
    response = None
    form = None

    try:
        user = User.objects.get(pk=urlsafe_base64_decode(uidb64))
        token_valid = default_token_generator.check_token(user, token)

        if token_valid:
            pwd_form = AdminPasswordChangeForm

            if request.method == 'POST':
                form = pwd_form(request.user, request.POST)
                if form.is_valid():
                    try:

front/templates/front/base_logged.html
<!-- TODO - when there is more than one app: all throughout the page replace 'wizard' for the selected app -->
{% load static %}
{% static "" as baseUrl %}
{% load i18n %}
{% get_current_language as LANGUAGE_CODE %}

<!DOCTYPE html>
<html lang="{{ LANGUAGE_CODE }}">
<head>
    <meta charset="UTF-8">
    <title>OPENCoastS</title>
    <!--<link rel="icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>
    <link rel="shortcut icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>-->
    <link rel="icon" type="image/png" href="{% static 'shared/img/favicon.png' %}" />

    <!-- JQuery -->
    <script src="{% static 'vendor/jquery/jquery-3.2.1.min.js' %}"></script>

    <!-- Bootstrap -->
    <link rel="stylesheet" href="{% static 'vendor/bootstrap/css/bootstrap.min.css' %}">
    <script src="{% static 'vendor/bootstrap/js/bootstrap.min.js' %}"></script>

    <!-- IntroJS -->
    <link rel="stylesheet" href="{% static 'vendor/intro/introjs.css' %}">
    <script src="{% static 'vendor/intro/intro.js' %}"></script>

    <!-- Google font -->
    <link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">

    <!-- Custom -->
    <link rel="stylesheet" href="{% static 'shared/css/style.css' %}">
    {% if app %}
    <!-- Get App's stylesheet -->
    <link rel="stylesheet" href="{{ baseUrl }}{{ app }}/css/style.css">
    {% endif %}
    <script src="{% static 'shared/js/custom.js' %}"></script>
</head>
<body>
    {% include "front/menu.html" %}

    <div class="container">
        <div class="main">
            {% block content %}
            {% endblock %}
        </div>
    </div>

    {% include "front/footer.html" %}
    {% include "front/modal/message.html" %}
    {% include "front/modal/confirm.html" %}

    {% if not request.session.deploy_id %}
    {% include "wizard/modal/inputname.html" %}
    {% endif %}

    <script type="text/javascript">
        // Global variables needed throughout all app
        {% if request.session.last_step %}
        var last_step = {{ request.session.last_step }};
        {% else %}
        var last_step = 0;
        {% endif %}

        {% if step %}
        var step = {{ step|default:0 }};
        {% else %}
        var step = 0;
        {% endif %}

        // On Document Ready
        $(function(){
            {% if msg_str %}
            $('#divModal_msg').modal('show');
            {% endif %}
        });
    </script>
</body>
</html>

front/templates/front/base_unlogged.html
{% load static %}
{% load i18n %}
{% get_current_language as LANGUAGE_CODE %}

<!DOCTYPE html>
<html lang="{{ LANGUAGE_CODE }}">
<head>
    <meta charset="UTF-8">
    <meta name="description" content="OPENCoastS coastal circulation on-demand forecast">
    <meta name="keywords" content="OPENCoastS, on-demand real time forecast, coastal circulation forecast, coastal circulation modelling, coastal modeling, SCHISM model, Web interface for on-demand forecast, INCD" />
    <title>OPENCoastS</title>
    <!--<link rel="icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>
    <link rel="shortcut icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>-->
    <link rel="icon" type="image/png" href="{% static 'shared/img/favicon.png' %}" />

    <!-- JQuery -->
    <script src="{% static 'vendor/jquery/jquery-3.2.1.min.js' %}"></script>
    <!-- Bootstrap -->
    <link rel="stylesheet" href="{% static 'vendor/bootstrap/css/bootstrap.min.css' %}">
    <script src="{% static 'vendor/bootstrap/js/bootstrap.min.js' %}"></script>

    <!-- Fontawesome-->
    <link rel="stylesheet" href="{% static 'vendor/font-awesome/css/font-awesome.min.css' %}">

    <!-- Google font -->
    <link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">

    <!-- Custom -->
    <link rel="stylesheet" href="{% static 'shared/css/style.css' %}">
    <link rel="stylesheet" href="{% static 'front/css/style.css' %}">
    <script src="{% static 'shared/js/custom.js' %}"></script>

    <!-- Global site tag (gtag.js) - Google Analytics -->
    <script async src="https://www.googletagmanager.com/gtag/js?id=UA-169433976-1"></script>
    <script>
      window.dataLayer = window.dataLayer || [];
      function gtag(){dataLayer.push(arguments);}
      gtag('js', new Date());

      gtag('config', 'UA-169433976-1');
    </script>
</head>
<body>
    {% include "front/menu.html" %}

    <div class="jumbotron text-center">
        <div class="bg"></div>
        <h1><img src="{% static 'shared/img/opencoasts_icon.png' %}" alt="opencoasts icon" /><span>OPENCoastS</span></h1>
        <h2>{% trans "Simulação a pedido na costa" %}</h2>
    </div>

    <div class="container">
        <div class="main">
            {% block content %}
            {% endblock %}
        </div>
    </div>

    {% include "front/footer.html" %}

    <script>
        $(function(){
            // Render current location on mainmenu
            // Need to add ids in li tags of class mainmenu
            $('li.mainmenu').removeClass('active');
            var path = window.location.pathname;
            path = (path != '/' ? path.replace(/\//g, '') : 'home');
            $('#'.concat(path)).addClass('active');
        });
    </script>
</body>
</html>

front/templates/front/disclaimer.html
<!-- No need to extend logged base -->
{% extends "front/base_unlogged.html" %}
{% load i18n %}

{% block content %}

      <h2>{% trans "Termos e Condições de Utilização" %}</h2>
      {% include "front/disclaimer_text.html" %}

{% endblock content %}

front/templates/front/error.html
<!-- No need to extend logged base -->
{% extends "front/base_unlogged.html" %}
{% load i18n %}

{% block content %}

  <div class="row">
    <div class="col-md-3"></div>
    <div class="col-md-6">

      <div class="alert alert-danger">
        <h3>{% trans "Lamentamos mas ocorreu um erro" %}</h3>
        <h5 class="text-danger">{{ error }}</h5>
      </div>
    </div>
    <div class="col-md-3"></div>
  </div>

{% endblock content %}

front/templates/front/footer.html
{% load static %}
{% load i18n %}

<div id="footer" class="navbar navbar-custom navbar-fixed-bottom">
    <nav class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar-collapse-footer" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <small>{% trans "Patrocinado por" %}</small>
          </button>
        </div>
        <div id="navbar-collapse-footer" class="collapse navbar-collapse">
            <div class="row footer">
                <div class="col-xs-4">
                    <!--
                    <a href="http://www.incd.pt/" target="_blank">
                        <img class="logo_l" src="{% static 'shared/img/incd.png' %}" title="Infraestrutura Nacional de Computação Distribuída" alt="incd logo" />
                    </a>
                    -->
                    <a href="https://www.eosc-hub.eu/" target="_blank">
                        <img class="logo_l" src="{% static 'shared/img/eosc-hub.png' %}" title="Services for the European Open Science Cloud" alt="eosc-hub logo" />
                    </a>
                    <a href="https://ec.europa.eu/" target="_blank">
                        <img class="logo_l" src="{% static 'shared/img/european-commission.png' %}" title="European Commission" alt="european commission logo" />
                    </a>
                    <a href="https://www.egi.eu/projects/egi-ace/" target="_blank">
                        <img class="logo_l" src="{% static 'shared/img/egi-ace.png' %}" title="EGI-ACE" alt="egi-ace logo" />
                    </a>
                </div>
                <div class="col-xs-8 text-right">
                    <span class="small" style="font-size: 7px;">
                        {% trans "Este trabalho usou a infraestrutura EGI com o suporte dedicado do projeto EGI-ACE." %}
                    </span>
                    <a href="http://www.lnec.pt/" target="_blank">
                        <img class="logo_r" src="{% static 'shared/img/logo_lnec.png' %}" title="Laboratório Nacional de Engenharia Civil" alt="lnec logo" alt="lnec logo" />
                    </a>
                    <a href="http://www.lip.pt/" target="_blank">
                        <img class="logo_r" src="{% static 'shared/img/lip.png' %}" title="Laboratório de Instrumentação e Física Experimental de Partículas" alt="lip logo" />
                    </a>
                    <span class="small">
                        &copy; LNEC/LIP 2018
                    </span>
                </div>
            </div>
        </div>
    </nav>
</div>

front/templates/front/login.html
{% extends "front/base_unlogged.html" %}
{% load static %}
{% load i18n %}

{% block content %}

  <div class="row">
    <div class="col-md-3"></div>
    <div class="col-md-6">
      <h1>{% trans "Entrar" %}</h1>
      <form class="form" method="post">{% csrf_token %}
        <table>
          <tr>
            <th>
              <label for="id_email">Email:</label>
            </th>
            <td>
              <input type="text" name="username" autofocus id="id_email" required />
            </td>
          </tr>
          <tr>
            <th>
              <label for="id_password">{% trans "Palavra-passe" %}:</label>
            </th>
            <td>
              <input type="password" name="password" id="id_password" required />
            </td>
          </tr>
        </table>

        <div class="row">
          <div class="col-xs-6">
            <a id="password_recover" class="small" href="#">{% trans "Esqueci-me da palavra-passe" %}</a>
          </div>
          <div class="col-xs-6 text-right">
            <button class="btn btn-default" type="button" onclick="window.location.href='{% url 'front:register' %}'">{% trans "Registar-se" %}</button>
            <button class="btn btn-primary" type="submit" value="login">{% trans "Entrar" %}</button>
          </div>
        </div>
      </form>
      <br>

      <p class="text-warning text-large">{{ response }}</p>

      <div class="row text-center">
        <p style="margin-top: 20px;">-- {% trans "Ou entre via autenticação federada" %} --</p>
        <button class="btn btn-primary" type="button" onclick="window.location.href='/auth/'" title="EGI Federation Service">
          <img src="{% static 'front/img/egi.png' %}" width="60" alt="egi logo" />
        </button>
      </div>

    </div>
    <div class="col-md-3"></div>
  </div>

  <script type="text/javascript">
    $(function(){
      $('#password_recover').on('click', function () {
          if ($('#id_email').val() == '') {
            msg = '{% trans "Para recuperar a sua palavra-passe terá de indicar primeiro o email associado à sua conta OPENCoastS." %}';
            $('.text-warning').html(msg);
            return false;
          }

          // Clear text
          $('.text-warning').html('{% trans "a processar.. aguarde por favor.." %}');

          // Send form data via client-side
          $.ajax({
              type: 'POST',
              url: '{% url 'front:password_recover' %}',
              data: $('.form').serialize(),
              success: function(data) {
                console.log(data);
                  if (data['response']) {
                      $('.text-warning').html(data['response']);
                  }
              },
              error: function(e, x, r) {
                  console.log(r + ' - ' + e);
                  $('.text-warning').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
              }
          });
      });
    });
  </script>

{% endblock content %}

front/templates/front/login_egi.html
{% extends "front/base_unlogged.html" %}
{% load static %}
{% load i18n %}

{% block content %}

  <div class="row">
    <div class="col-md-3"></div>
    <div class="col-md-6">
      <h1>{% trans "Autenticação" %}</h1>

      {% if response %}
        <p class="text-warning text-large">{{ response }}</p>

      {% if profile_form and user_form %}
      <form class="form" method="post">{% csrf_token %}
        <table>
          {{ user_form.as_table }}
          {{ profile_form.as_table }}
        </table>

        <div class="row">
          <div class="col-xs-6">
          </div>
          <div class="col-xs-6 text-right">
            <button
                id="confirm_button"
                class="btn btn-primary"
                type="submit"
                value="register">
              {% trans "Concluir Registo" %}
            </button>
          </div>
        </div>
      </form>
      <p id="msg_place" class="text-warning text-large"></p>
      {% endif %}
      {% endif %}
    </div>
    <div class="col-md-3"></div>
  </div>

  <script type="text/javascript">
    // Button Submit
    $('[type="submit"]').click(function(e){
        e.preventDefault();
        $('#msg_place').html('');

        var flagok = true;
        var msg = '{% trans "Para continuar terá de preencher todos os campos." %}';

        try {
            // Validate form
            $('.form input, .form select').each(function(){
                if ($(this).prop('required') && $(this).val() == '') {
                    flagok = false;
                    return false;
                }
            });

            if (!flagok) {
                $('#msg_place').html(msg);
                return false;
            }

            // Send form data via client-side
            $.ajax({
                type: 'POST',
                url: '{% url 'front:login_egi_complete' %}',
                data: $('.form').serialize(),
                success: function(data) {
                    if (data['msg']) $('#msg_place').html(data['msg']);
                },
                error: function(e, x, r) {
                    console.log(r + ' - ' + e);
                    $('#msg_place').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                }
            });

            $('.form :input').prop('disabled', true);

        } catch(err) {
            e.preventDefault();
            console.log(err);
            $('#msg_place').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
        }
    });
  </script>

{% endblock content %}

front/templates/front/password.html
<!-- No need to extend logged base -->
{% extends "front/base_unlogged.html" %}
{% load i18n %}

{% block content %}

  <div class="row">
    <div class="col-md-3"></div>
    <div class="col-md-6">
      <h1>{% trans "Alterar Palavra-passe" %}</h1>

      {% if pwd_form %}
      <form class="form" method="post">{% csrf_token %}
        <table>
          {{ pwd_form.as_table }}
        </table>

        <div class="row">
          <div class="col-xs-6">
          </div>
          <div class="col-xs-6 text-right">
            <button class="btn btn-primary" type="submit" value="register">{% trans "Alterar" %}</button>
          </div>
        </div>
      </form>
      {% endif %}

      {% if response %}
      <p class="text-warning text-large">{{ response }}</p>

      {% if not user.is_authenticated and token_valid %}
      <button class="btn btn-default" onclick="location.href='{% url 'front:login' %}'"> {% trans "Entrar em sessão" %}</button>
      {% endif %}

      {% endif %}

      {% if user.is_authenticated %}
      <button class="btn btn-default" onclick="location.href='{% url 'front:profile' %}'"><span class="glyphicon glyphicon-arrow-left"></span> {% trans "Voltar ao Perfil" %}</button>
      {% endif %}
    </div>
    <div class="col-md-3"></div>
  </div>

{% endblock content %}